
#pragma once

#include "cBlockEntity.h"
#include "cWindowOwner.h"





namespace Json
{
	class Value;
};

class cClientHandle;
class cServer;
class cItem;
class cNBTData;





class cChestEntity :
	public cBlockEntity,
	public cBlockEntityWindowOwner
{
public:
	cChestEntity(int a_X, int a_Y, int a_Z, cWorld * a_World);
	virtual ~cChestEntity();
	virtual void Destroy();

	void HandleData( cNBTData* a_NBTData );

	const cItem * GetSlot( int a_Slot ) const;
	void	SetSlot( int a_Slot, cItem & a_Item );

	bool LoadFromJson( const Json::Value& a_Value );
	virtual void SaveToJson(Json::Value& a_Value ) override;

	virtual void SendTo(cClientHandle & a_Client) override;

	virtual void UsedBy( cPlayer * a_Player ) override;

	cChestEntity *GetJoinedChest() { return m_JoinedChest; }
	void SetJoinedChest(cChestEntity *a_Chest) { m_JoinedChest = a_Chest; }
	void RemoveJoinedChest(cChestEntity *a_Chest) { if (m_JoinedChest && m_JoinedChest == a_Chest) { m_JoinedChest = NULL; m_TopChest = false; } }

	int GetChestHeight() { return ((m_JoinedChest) ? c_ChestHeight * 2 : c_ChestHeight); }
	cItem * GetContents(bool a_OnlyThis = false);

	static const int c_ChestWidth = 9;
	static const int c_ChestHeight = 3;
	
private:

	cItem *        m_Content;
	bool           m_TopChest;
	cChestEntity * m_JoinedChest;
};




